﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Extras
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Sum: {0}", Sum(10));
            Console.WriteLine("Sum: {0}", Sum(10, 20, 30));

            Console.WriteLine("Max: {0}", Max(10));
            Console.WriteLine("Max: {0}", Max(20, 40, 10, 60, 30, 0));

            var fruits = new List<String> { "apple", "pear", "banana", "orange", "lemon" };
            var firstFruit = fruits[0];

            var selection = from fruit in fruits
                        where fruit.Contains("e")
                        orderby fruit.Length, fruit descending
                        select fruit.ToUpper();

            /*
            selection = fruits
                .Where(f => f.Contains("e"))
                .OrderBy(f => f.Length).OrderByDescending(f => f)
                .Select(f => f.ToUpper());
            */

            Console.WriteLine("Fruits:");
            foreach (var item in selection)
                Console.WriteLine("\t" + item);

            dynamic dyn = "The quick brown fox jumps over the lazy dog";
            Console.WriteLine(dyn.ToUpper());

            try
            {
                Console.WriteLine(dyn.NonExistentMethod());
            }
            catch (Microsoft.CSharp.RuntimeBinder.RuntimeBinderException)
            {
                Console.WriteLine("No NonExistentMethod exists in type {0}.", dyn.GetType());
            }

            Console.ReadKey();
        }

        static Int32 Sum(Int32 init, params Int32[] operands)
        {
            foreach (Int32 operand in operands)
                init += operand;
            return init;
        }

        static T Max<T>(T first, params T[] others) where T : IComparable<T>
        {
            T max = first;
            foreach (T other in others)
                if (other.CompareTo(max) > 0)
                    max = other;
            return max;
        }
    }
}
