﻿using System;
using System.Collections.Generic;

namespace GenericSample
{
    class PriorityQueue<T>
    {
        private List<T> _values;

        public PriorityQueue()
        {
            _values = new List<T>();
        }

        public void Push(T v)
        {
            _values.Add(v);
            _values.Sort();
        }

        public T Pop()
        {
            if (_values.Count == 0)
                throw new OverflowException("The queue is empty.");

            T ret = _values[0];
            _values.RemoveAt(0);
            return ret;
        }

        public Int32 Size
        {
            get { return _values.Count; }
        }
    }
}
