﻿using System;

namespace RectangleWithPoints
{
    class Rectangle
    {
        private Point _A;
        private Point _B;

        public Rectangle(Int32 aX, Int32 aY, Int32 bX, Int32 bY)
        {
            _A = new Point(aX, aY);
            _B = new Point(bX, bY);
        }

        public Rectangle(Point a, Point b)
        {
            _A = a;
            _B = b;
        }

        public void Move(Vector v)
        {
            _A.Move(v);
            _B.Move(v);
        }

        public Int32 Perimeter
        {
            get { return 2 * (Math.Abs(_B.X - _A.X) + Math.Abs(_B.Y - _A.Y)); }
        }

        public Int32 Area
        {
            get { return Math.Abs(_B.X - _A.X) * Math.Abs(_B.Y - _A.Y); }
        }
    }
}
