﻿using System;

namespace SimpleRational
{
    class Rational
    {
        public Int32 Nominator { get; set; }

        private UInt32 _denominator = 1;

        public UInt32 Denominator
        {
            get { return _denominator; }
            set
            {
                if (value == 0)
                    throw new DivideByZeroException("The denominator cannot be zero.");

                _denominator = value;
            }
        }

        public Rational(Int32 nominator = 0, UInt32 denominator = 1)
        {
            Nominator = nominator;
            Denominator = denominator;
        }

        public Double GetValue()
        {
            return (Double)Nominator / Denominator;
        }

        public override string ToString()
        {
            return String.Format("{0} / {1}", Nominator, Denominator);
        }
    }
}
