﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SimpleStack
{
    class Stack
    {
        private Single[] _values;
        private Int32 _top;

        public Stack(Int32 maxSize)
        {
            _values = new Single[maxSize];
            _top = 0;
        }

        public void Push(Single v)
        {
            if (_top < _values.Length)
            {
                _values[_top] = v;
                _top++;
            }
            else
                throw new OverflowException("The stack is full.");
        }

        public void Pop()
        {
            if (_top > 0)
                _top--;
            else
                throw new OverflowException("The stack is empty.");
        }

        public Single Top
        {
            get
            {
                if (_top > 0)
                    return _values[_top - 1];
                else
                    throw new OverflowException("The stack is empty.");
            }
        }

        public Int32 Size
        {
            get { return _top; }
        }
    }
}
