﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace University
{
    class Teacher
    {
        private List<Course> _Courses;

        public String Name { get; private set; }
        public String UniversityCode { get; private set; }

        public List<String> CourseNames
        {
            get
            {
                List<String> courseNames = new List<String>();
                foreach (Course course in _Courses)
                    courseNames.Add(course.Name);
                return courseNames;
            }
        }

        public Teacher(String name)
        {
            Name = name;
            _Courses = new List<Course>();

            String[] nameParts = Name.Split(new char[] { ' ' });
            UniversityCode = nameParts[1].ToLower()[0] + nameParts[0].ToLower();
        }

        public Course CreateCourse(String name)
        {
            Course course = new Course(this, name);
            _Courses.Add(course);
            return course;
        }

        public Course GetCourse(String name)
        {
            foreach (Course course in _Courses)
                if (course.Name == name)
                    return course;
            return null;
        }
    }
}
